/***************************************************************************/
/*                                                                         */
/*                         Sound Source File                               */
/*                                                                         */
/*     Initialisation, shuting down and PC Engine generation of sound      */
/*                                                                         */
/***************************************************************************/

/* Header */

#include <malloc.h>
#include "utils.h"
#include "sound.h"

/* Variables definition */

UChar sound_driver = 1;
// 0 =- No sound driver
// 1 =- Allegro sound driver
// 2 =- Seal sound driver
// 3 =- SDL/SDL_Mixer driver

char MP3_playing = 0;
// is MP3 playing ?

char *sbuf[6];
// the buffer where the "DATA-TO-SEND-TO-THE-SOUND-CARD" go
// one for each channel

UChar new_adpcm_play = 0;
// Have we begun a new adpcm sample (i.e. must be reset adpcm index/prev value)

// the mixed buffer, may be removed later for hard mixing...

UInt32 CycleOld;
UInt32 CycleNew;
// indicates the last time music has been "released"

// the freq of the internal PC Engine CPU
// the sound use a kind of "relative" frequency
// I think there's a pb with this value that cause troubles with some cd sync

// mono or stereo, to remove later

UInt32 dwNewPos;

UInt32 AdpcmFilledBuf = 0;
// Size (in nibbles) of adpcm buf that has been filled with new data

/* Functions definition */
int InitSound(void)
{
  int i;

  silent = 0;
# if 0 //LUDO: old SDL sound stuff
  for (i = 0; i < 6; i++)
    sbuf[i] = (char *) calloc(sizeof(char), 4 * 1024);
# endif
  return 0;
}

void
TrashSound (void)		/* Shut down sound  */
{
}

/* TODO : doesn't support repeat mode for now */

void write_adpcm(void)
{
  UInt32 Cycle;
# if 0 //LUDO:
  UInt32 AdpcmUsedNibbles;
  static SChar index;
  static SInt32 previousValue;
# endif

  if (CycleNew != CycleOld)
    {
      Cycle = CycleNew - CycleOld;
      CycleOld = CycleNew;

      dwNewPos = (unsigned) ((float) (host.sound.freq) * (float) Cycle / (float) BaseClock);
      // in fact, size of the data to write
    };

# if 0 //LUDO:
  AdpcmFilledBuf = dwNewPos;

  if (new_adpcm_play)
    {
      index = 0;
      previousValue = 0;
    }

  if (AdpcmFilledBuf > io.adpcm_psize)
    AdpcmFilledBuf = io.adpcm_psize;

  AdpcmUsedNibbles =
    WriteBufferAdpcm8 ((UChar *)adpcmbuf,
		       io.adpcm_pptr, AdpcmFilledBuf, &index, &previousValue);

  io.adpcm_pptr += AdpcmUsedNibbles;
  io.adpcm_pptr &= 0x1FFFF;

  if (AdpcmUsedNibbles)
    io.adpcm_psize -= AdpcmUsedNibbles;
  else
# endif
    io.adpcm_psize = 0;
  /* If we haven't played even a nibbles, it problably mean we won't ever be
   * able to play one, so we stop the adpcm playing
   */
}

